﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Imaging;
using System.Text;
using System.Windows.Forms;
using System.Threading;

using AForge;
using AForge.Video;
using AForge.Video.DirectShow;
using AForge.Imaging;
using AForge.Imaging.Filters;
using System.IO;

namespace Camera
{
    public partial class Test : Form
    {
        private FilterInfoCollection videoDevices;

        VedioHangAn vedio;



        public Test()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            try
            {
                // 枚举所有视频输入设备
                videoDevices = new FilterInfoCollection(FilterCategory.VideoInputDevice);
                

                if (videoDevices.Count == 0)
                    throw new ApplicationException();

                foreach (FilterInfo device in videoDevices)
                {
                    tscbxCameras.Items.Add(device.Name);
                }

                tscbxCameras.SelectedIndex = 0;



                vedio = new VedioHangAn(pictureBox1);

            }
            catch (ApplicationException)
            {
                tscbxCameras.Items.Add("No local capture devices");
                videoDevices = null;
            }
        }

        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            CameraConn();
        }

        //连接摄像头
        private void CameraConn()
        {
            VideoCaptureDevice videoSource = new VideoCaptureDevice(videoDevices[tscbxCameras.SelectedIndex].MonikerString);
            //videoSource.DesiredFrameSize = new Size(320, 240);
            videoSource.DesiredFrameSize = new Size(pictureBox1.Width, pictureBox1.Height);
            videoSource.DesiredFrameRate = 1;

            videoSource.NewFrame += new NewFrameEventHandler(videoSource_NewFrame);
            videPlayer.VideoSource = videoSource;
            videPlayer.Start();




            //VedioCapture _VC = new VedioCapture();
            //_VC.Stop();
            //_VC.Start(pictureBox1.Handle, 0, 0, pictureBox1.Width, pictureBox1.Height);

        }

        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            videPlayer.SignalToStop();
            videPlayer.WaitForStop();
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            toolStripButton2_Click(null, null);
            button1_Click(null, null);
        }

        /// <summary>
        /// 保存图片
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void toolStripButton3_Click(object sender, EventArgs e)
        {
            System.Drawing.Image img = new Bitmap(videPlayer.Width, videPlayer.Height);
            videPlayer.DrawToBitmap((Bitmap)img, new Rectangle(0, 0, videPlayer.Width, videPlayer.Height));
            img.Save(@"E:/a.bmp", ImageFormat.Bmp);

        }


        void videoSource_NewFrame(object sender, NewFrameEventArgs eventArgs)
        {
            if (false)
                return;
            try
            {
                Bitmap bitmap = (Bitmap)eventArgs.Frame.Clone();
                fun(bitmap);

            }
            catch (Exception ex)
            {
                //label1.Text = "保存图像失败!";
            }
        }

        //加载图片到控件 
        private delegate void UpdateUI();
        private void fun(Bitmap img)
        {

            if (this.pictureBox1.InvokeRequired)
            {
                UpdateUI update = delegate { this.pictureBox1.Image = img; };
                this.pictureBox1.Invoke(update);
            }
            else
            {
                this.pictureBox1.Image = img;
            }

        }


        private void toolStripButton4_Click(object sender, EventArgs e)
        {
            try
            {
                vedio.Start();
            }
            catch (Exception ex)
            {

                throw;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            vedio.Stop();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            pictureBox2.Image = pictureBox1.Image;
        }
    }
}
