﻿/********************************************************************************
 * File Name    : VedioHangAn
 * Creator      : mq
 * Create Time  : 2019-02-27 08:25:07
 * Description  : 
 * Remark       : 
 * 
 * 
 ********************************************************************************/

using AForge.Video;
using AForge.Video.DirectShow;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Text;

namespace Camera
{


    /// <summary>
    /// 智慧航安摄像头
    /// </summary>
    public class VedioHangAn
    {
        private System.Windows.Forms.PictureBox pictureBox1 = null;
        private FilterInfoCollection videoDevices;
        private VideoCaptureDevice videoSource;
        private bool isRunning = false;

        

        public VedioHangAn(System.Windows.Forms.PictureBox picBox)
        {
//            GrabImage = System.Drawing.Image.FromFile;
            pictureBox1 = picBox;
            pictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;

            videoDevices = new FilterInfoCollection(FilterCategory.VideoInputDevice);
            if (videoDevices.Count == 0)
                throw new ApplicationException();


        }

        public bool Start()
        {

            if (!isRunning)
            {

                videoSource = new VideoCaptureDevice(videoDevices[0].MonikerString);
                videoSource.DesiredFrameSize = new Size(pictureBox1.Width, pictureBox1.Height);
                videoSource.DesiredFrameRate = 1;
                videoSource.NewFrame += new NewFrameEventHandler(videoSource_NewFrame);


                if (videoSource != null)
                {
                    videoSource.Start();
                    isRunning = true;
                }
            }
            else
            {

            }
            return false;
        }


        public bool Stop()
        {
            bool isStop = false;
            try
            {
                if (isRunning)
                {
                    videoSource.SignalToStop();
                    //videoSource.WaitForStop();
                    //videoSource.Stop();
                    isStop = true;
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
            finally
            {
                videoSource = null;
                //videoDevices = null;
                //pictureBox1 = null;
                isRunning = false;
            }

            return isStop;
        }


        //加载图片到控件 
        private delegate void UpdateUI();

        private void UpdatePictureBox(Bitmap img)
        {

            if (this.pictureBox1.InvokeRequired)
            {
                UpdateUI update = delegate { this.pictureBox1.Image = img; };
                this.pictureBox1.Invoke(update);
            }
            else
            {
                this.pictureBox1.Image = img;
            }

        }

        private void videoSource_NewFrame(object sender, NewFrameEventArgs eventArgs)
        {
            if (!isRunning)
                return;
            try
            {
                Bitmap bitmap = (Bitmap)eventArgs.Frame.Clone();
                //GetImage = bitmap;
                UpdatePictureBox(bitmap);
            }
            catch (Exception ex)
            {
            }
        }



    }
}
